#include "BATesting.h"
#include "Device/Data/Powerfield.h"
#include "Device/Histo/IOFactory.h"
#include "Tests/GTestWrapper/google_test.h"

class ReadSANSDRawTest : public ::testing::Test {
};

TEST_F(ReadSANSDRawTest, Read)
{
    const auto fname = BATesting::ExampleDataDir() + "/SANSDRaw.001";
    Powerfield<double>* data = IOFactory::readPowerfield(fname, IOFactory::automatic);
    EXPECT_NE(data, nullptr);
    if (!data)
        return;
    EXPECT_EQ(data->rank(), 2);
    EXPECT_EQ(data->allocatedSize(), 16384);
    EXPECT_EQ((*data)[128 * 70 + 62], 443);
}
