find_package(OpenGL REQUIRED)
find_package(Qt5 COMPONENTS Core Gui Widgets PrintSupport Svg OpenGL REQUIRED)

message(STATUS "Found Qt5 version ${Qt5Widgets_VERSION}")

if(${Qt5Core_VERSION} VERSION_LESS "5.12")
    message(FATAL_ERROR "Qt 5.12 is required, have ${Qt5Core_VERSION_STRING}")
elseif(${Qt5Core_VERSION} VERSION_GREATER_EQUAL "5.15")
    string(APPEND CMAKE_CXX_FLAGS " -DQT_NO_DEPRECATED_WARNINGS")
endif()

set(Qt_DIR "${Qt5_DIR}" CACHE INTERNAL "")
set(Qt_VERSION "${Qt5Core_VERSION_STRING}" CACHE INTERNAL "")
set(Qt_INCLUDE_DIR "${Qt5Widgets_INCLUDE_DIRS}" CACHE INTERNAL "")
foreach(cmp Core Gui Widgets PrintSupport Svg OpenGL)
    string(APPEND qt_libs " ${Qt5${cmp}_LIBRARIES}")
endforeach()
set(Qt_LIBRARIES "${qt_libs}" CACHE INTERNAL "")

message(STATUS "  Qt5 directory: ${Qt5_DIR}")
get_target_property(Qt5Widgets_location Qt5::Widgets LOCATION_Release)
message(STATUS "  ${Qt5Widgets_LIBRARIES} ${Qt5Widgets_location}")
get_target_property(Qt5Core_location Qt5::Core LOCATION_Release)
message(STATUS "  ${Qt5Core_LIBRARIES} ${Qt5Core_location}")
get_target_property(Qt5Gui_location Qt5::Gui LOCATION_Release)
message(STATUS "  ${Qt5Gui_LIBRARIES} ${Qt5Gui_location}")
get_target_property(Qt5OpenGL_location Qt5::OpenGL LOCATION_Release)
message(STATUS "  ${Qt5OpenGL_LIBRARIES} ${Qt5OpenGL_location}")
message(STATUS "  Includes: ${Qt5Widgets_INCLUDE_DIRS}")
